using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PixcavatorFrameworkNET;

namespace SampleApplicationCsharp
{
    public partial class Form1 : Form
    {
        private string _fileName;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "All Image Files|*.tif;*.tiff;*.bmp;*.png;*.jpg;*.jpeg;*.gif;*.stk";
            DialogResult res = fd.ShowDialog();
            if (res != DialogResult.OK)
                return;
            _fileName = fd.FileName;
            pictureBox1.Load(_fileName);
            numericUpDown1.Maximum = (decimal)Math.Round(0.15 * pictureBox1.Image.Height * pictureBox1.Image.Width);
            numericUpDown3.Maximum = (decimal)Math.Round((double)pictureBox1.Image.Height * pictureBox1.Image.Width / 2500 * 40);
            numericUpDown3.Value = numericUpDown3.Maximum;
            button2.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            PixcavatorFramework pf = new PixcavatorFramework();
            List<PixObject> objects = null;
            try
            {
                objects = pf.AnalyzeImage(_fileName, (int)numericUpDown1.Value, (int)numericUpDown2.Value,
                    (int)numericUpDown3.Value, (int)numericUpDown4.Value);
            }
            catch (MaximumSizeExceededException)
            {
                MessageBox.Show("Maximum image size for the demo version is 40000 pixels.", "Image size", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            dataGridView1.DataSource = objects;

            Bitmap bmp = new Bitmap(_fileName);
            string tempFileName = Path.GetTempFileName();
            bmp.Save(tempFileName, System.Drawing.Imaging.ImageFormat.Jpeg);
            bmp = new Bitmap(tempFileName);

            foreach (PixObject obj in objects)
            {
                Color color = obj.Type == PixObjectType.Dark ? Color.Red : Color.Green;
                foreach (Point p in obj.Contour)
                    if (p.X > 0 && p.X < pictureBox1.Image.Width && p.Y > 0 && p.Y < pictureBox1.Image.Height)
                        bmp.SetPixel(p.X, p.Y, color);
            }
            pictureBox1.Image = bmp;
        }
    }
}